//---------------------------------------------------------------------------
//(R)CopyRight KivenSoft International ,inc 1999
//椸W١GƮw椸
//{W١GqlѮw
//@    ̡G|
//}lɶG1998.07.28
//̫קG1999.07.22
//ƵG椸wqFSRMŪg
//---------------------------------------------------------------------------
unit SrmUnit;

interface

uses
  Windows,SysUtils,Classes, SrmConst;


type
PCharArray=^TCharArray;
TCharArray=array[0..0] of char;
PDwordArray=^TDwordArray;
TDwordArray=array[0..0] of DWORD;
PIntArray=^TIntArray;
TIntArray=array[0..0] of integer;

PTreeData=^TTreeData;
TTreeData=record        //޸T
  Pos: longint;
  DataType: longint;
end;
PTdArray=^TTdArray;
TTdArray=array[0..0] of TTreeData;

PFileHead=^TFileHead;
TFileHead=record
  OpenFlag      :Longint;                      //Ʈw}лx
  LastViewPos   :longint;                   //ɪm
  IndexPos      :longint;                   //ަm
  EditDate      :TDateTime;                 //̫ק
  Key           :DWORD;                     //K_
  Password      :array[0..11] of char;      //fO
  Author        :array[0..15] of char;      //@
  BuildDate     :TDateTime;                 //خw
  DataType      :longint;                   //Ʈw榡
  DataFlag      :array[0..7] of char;       //Ʈwлx
  Version       :longint;                   //Ʈw
  BookMerg      :array[0..9] of longint;    //10Ӯ
  Keep          :longint;                   //Od
end;

//DataType 0:Index    1:Normal Dir     2:Notmal TXT    3:Normal HTML
PIndexHead=^TIndexHead;
TIndexHead=record
  DataType      :longint;                   //q
  Key           :DWORD;                     //K_
  Count         :longint;                   //Dƶq
  Size          :longint;                   //D
  Keep          :longint;                   //Od
end;

PDataHead=^TDataHead;
TDataHead=record
  DataType      :longint;                   //q
  Author        :array[0..15] of char;      //@
  PubDate       :TDateTime;                 //
  Key           :DWORD;                     //K_
  Num           :longint;                   //ƶq
  SearchKey     :array[0..51] of char;      //r
  Password      :array[0..11] of char;      //fO
  Keep          :longint;                   //Od
end;

//------------------------------------------------------------------------
TSrmObject=class
  private
    FChangeFlag         :boolean;   //bᦳW[sTܼ
    FDbChanged          :boolean;   //ƾڮwݩʦܰ
    FIndexChanged       :boolean;   //ަܰ
    FItemHeadChanged    :boolean;   //DYܰ
    FItemDataChanged    :boolean;   //Deܰ
    FFileHead           :TFileHead;
    FIndexHead          :TIndexHead;
    FDataHead           :TDataHead;
    FFileHandle         :integer;       //󱱨X
    FFileName           :string;
    FActivePos          :longint;       //eŪXem

    procedure Encypher(Cypher:DWORD;var Buf;Count:integer);
    procedure Decypher(Cypher:DWORD;var Buf;Count:integer);
    procedure CreateSrmFile;            //إߤ@ӪŸƮw
    procedure SetDbChanged(Value:boolean);
    procedure SetIndexChanged(Value:boolean);
    procedure SetItemHeadChanged(Value:boolean);
    procedure SetItemDataChanged(Value:boolean);
  public
    property FileName:string read FFileName;
    property FileHead:TFileHead read FFileHead write FFileHead;
    property IndexHead:TIndexHead read FIndexHead write FIndexHead;
    property DataHead:TDataHead read FDataHead write FDataHead;
    property ActivePos:longint read FActivePos write FActivePos;
    property DbChanged:boolean read FDbChanged write SetDbChanged;
    property IndexChanged:boolean read FIndexChanged write SetIndexChanged;
    property ItemHeadChanged:boolean read FItemHeadChanged write SetItemHeadChanged;
    property ItemDataChanged:boolean read FItemDataChanged write SetItemDataChanged;

    constructor Create(Fn:string;Mode:Word);
    destructor Destroy;override;
    procedure Free;
    procedure SaveSrmFile;          //󱡪pUOs
    procedure LoadIndex(Msh,Msd:TMemoryStream); //Ū
    procedure SaveIndex(Msh,Msd:TMemoryStream);//g
    class function IsSrmFile(var Fn:string):boolean;//P_O_OSRM榡Ʈw
    procedure ReadItemHead(Ps:longint);  //ŪƬqY
    procedure ReadItemData(DataStream:TMemoryStream);  //ŪƬqe
    procedure EditItemHead(Ps:longint);    //קY
    function AddItemHead:longint;          //gƬqY
    procedure AddItemData(DataStream:TMemoryStream); //gƬqe
    function GetItemPassword(Ps:longint):string; //oYDfO
 end;
//------------------------------------------------------------------------


implementation

//------------------------------------------------------------------------
procedure TSrmObject.Encypher(Cypher:DWORD;var Buf;Count:integer);
var
  i:integer;
begin
  Cypher:=not Cypher;
  Dec(Count);
  for i:=0 to Count do
    TDwordArray(Buf)[i]:=TDwordArray(Buf)[i] xor Cypher;
end;

procedure TSrmObject.Decypher(Cypher:DWORD;var Buf;Count:integer);
var
  i:integer;
begin
  Cypher:=not Cypher;
  Dec(Count);
  for i:=0 to Count do
    TDwordArray(Buf)[i]:=TDwordArray(Buf)[i] xor Cypher;
end;
//------------------------------------------------------------------------

procedure TSrmObject.CreateSrmFile;    //إߤ@ӪŸƮw
var
  i:integer;
begin
    FFileHandle:=FileCreate(FFileName);
    if FFileHandle=-1 then raise Exception.Create(csCanNotCreate);
    //KRʬٸTY
    with FFileHead do
    begin
      OpenFlag:=0;
      LastViewPos:=0;
      IndexPos:=sizeof(TFileHead);
      EditDate:=Now;
      Key:=GetTickCount;
      Password[0]:=#0;
      Author[0]:=#0;
      BuildDate:=EditDate;
      DataType:=0;
      Version:=3;
      Keep:=0;
      DataFlag[0]:='K';
      DataFlag[1]:='i';
      DataFlag[2]:='v';
      DataFlag[3]:='e';
      DataFlag[4]:='n';
      for i:=0 to 9 do BookMerg[i]:=-1;
    end;
    //KRʬٯ
    with FIndexHead do
    begin
      DataType:=0;
      Key:=GetTickCount;
      Count:=0;
      Size:=0;
      Keep:=0;
    end;
    //[KgJѱK
    with FFileHead do
    begin
      Encypher(Key,Author,4);
      Encypher(Key,Password,3);
      FileWrite(FFileHandle,FFileHead,sizeof(TFileHead));
      FileWrite(FFileHandle,FIndexHead,sizeof(TIndexHead));
      Decypher(Key,Author,4);
      Decypher(Key,Password,3);
    end;
end;

constructor TSrmObject.Create(Fn:string;Mode:Word);
begin
  FFileName:=Fn;
  FChangeFlag:=false;
  FDbChanged:=false;
  FIndexChanged:=false;
  FItemHeadChanged:=false;
  FItemDataChanged:=false;
  FDataHead.Keep:=0;
  //}ŪYA_hطs
  if Mode=fmOpenReadWrite then
  begin
    FFileHandle:=FileOpen(FFileName,fmOpenReadWrite);
    FileRead(FFileHandle,FFileHead,sizeof(TFileHead));
    with FFileHead do
    begin
      Decypher(Key,Password,3);
      Decypher(Key,Author,4);
    end;
  end
  else if Mode=fmCreate then
  begin
    CreateSrmFile;
  end;
end;

destructor TSrmObject.Destroy;
begin
  if FFileHandle<>-1 then
  begin
    FileClose(FFileHandle);  //
    FFileHandle:=-1;
  end;
  inherited;
end;

procedure TSrmObject.Free;
begin
  if Assigned(self) then Destroy;
end;

procedure TSrmObject.SaveSrmFile;
begin
  //gJs᪺Y
  with FFileHead do
  begin
    FileSeek(FFileHandle,0,0);
    EditDate:=Now;
    Key:=GetTickCount;
    Encypher(Key,Password,3);
    Encypher(Key,Author,4);
    FileWrite(FFileHandle,FFileHead,sizeof(TFileHead));
    Decypher(Key,Password,3);
    Decypher(Key,Author,4);
  end;
end;

class function TSrmObject.IsSrmFile(var Fn:string):boolean;
var
  Fh: TFileHead;
  Fs: TFileStream;
begin
  Result:=false;
  Fs:=TFileStream.Create(Fn,fmOpenRead);
  //ھڤקP_
  with Fs do
  begin
    if (Size<(sizeof(TFileHead)+sizeof(TIndexHead))) then
    begin
      Free;
      Result:=false;
      Exit;
    end;
    Read(Fh,sizeof(TFileHead));
    Free;
  end;
  //ھڤлxP_
  with Fh do
  begin
    if ( (DataFlag[0]='K') and (DataFlag[1]='i') and
        (DataFlag[2]='v') and (DataFlag[3]='e') and
        (DataFlag[4]='n') ) then
      Result:=true;
  end;
end;

procedure TSrmObject.LoadIndex(Msh,Msd:TMemoryStream);
begin
  //ŪXY
  FileSeek(FFileHandle,FFileHead.IndexPos,0);
  FileRead(FFileHandle,FIndexHead,sizeof(TIndexHead));
  //Bzު׬0pA_hŪX
  if (FIndexHead.Size=0) then
  begin
    Msh.SetSize(0);
    Msd.SetSize(0);
  end
  else
  begin
    Msh.SetSize(FIndexHead.Size);
    Msd.SetSize(FIndexHead.Count*sizeof(longint)*2);
    FileRead(FFileHandle,Msh.Memory^,Msh.Size);
    FileRead(FFileHandle,Msd.Memory^,Msd.Size);
    Decypher(FIndexHead.Key,Msh.Memory^,Msh.Size div 4);
  end;
end;

procedure TSrmObject.SaveIndex(Msh,Msd:TMemoryStream);
begin
  if FChangeFlag then  //W[Lse
    FFileHead.IndexPos:=FileSeek(FFileHandle,0,2)
  else                 //LsWe
    FileSeek(FFileHandle,FFileHead.IndexPos,0);
  //]mY
  with FIndexHead do
  begin
    Key:=GetTickCount;
    Size:=Msh.Size;
    Count:=Msd.Size div (sizeof(longint)*2);
  end;
  //[KDe
  Encypher(FIndexHead.Key,Msh.Memory^,Msh.Size div 4);
  //gJ
  FileWrite(FFileHandle,FIndexHead,sizeof(TIndexHead));
  FileWrite(FFileHandle,Msh.Memory^,Msh.Size);
  FileWrite(FFileHandle,Msd.Memory^,Msd.Size);
end;

procedure TSrmObject.ReadItemHead(Ps:longint);
begin
  FActivePos:=Ps;  //OseƦm
  //ŪXøѱK
  with FDataHead do
  begin
    FileSeek(FFileHandle,Ps,0);
    FileRead(FFileHandle,FDataHead,sizeof(TDataHead));
    Decypher(Key,SearchKey,13);
    Decypher(Key,Author,4);
    Decypher(Key,Password,3);
  end;
end;

procedure TSrmObject.ReadItemData(DataStream:TMemoryStream);
var
  size:longint;
begin
  //ŪX餺e
  FileRead(FFileHandle,size,sizeof(longint));
  DataStream.SetSize(size);
  FileRead(FFileHandle,DataStream.Memory^,size);
  Decypher(FDataHead.Key,DataStream.Memory^,size div 4);
end;

procedure TSrmObject.EditItemHead(Ps:longint);
begin
  //קY
  FileSeek(FFileHandle,Ps,0);
  with FDataHead do
  begin
    Encypher(Key,SearchKey,13);
    Encypher(Key,Author,4);
    Encypher(Key,Password,3);
    FileWrite(FFileHandle,FDataHead,sizeof(TDataHead));
    Decypher(Key,SearchKey,13);
    Decypher(Key,Author,4);
    Decypher(Key,Password,3);
  end;
end;

function TSrmObject.AddItemHead:longint;
begin
  //seW[ɲK[
  FChangeFlag:=true;
  with FDataHead do
  begin
    Result:=FileSeek(FFileHandle,0,2);
    Key:=GetTickCount;
    PubDate:=Now;
    Encypher(Key,SearchKey,13);
    Encypher(Key,Author,4);
    Encypher(Key,Password,3);
    FileWrite(FFileHandle,FDataHead,sizeof(TDataHead));
    Decypher(Key,SearchKey,13);
    Decypher(Key,Author,4);
    Decypher(Key,Password,3);
  end;
end;

procedure TSrmObject.AddItemData(DataStream:TMemoryStream);
var
  size:longint;
begin
  size:=DataStream.Size;
  FileWrite(FFileHandle,size,sizeof(longint));
  Encypher(FDataHead.Key,DataStream.Memory^,size div 4);
  FileWrite(FFileHandle,DataStream.Memory^,size);
end;

function TSrmObject.GetItemPassword(Ps:longint):string; //oYDfO
var
  Dh:TDataHead;
begin
  //ŪXøѱK
  with Dh do
  begin
    FileSeek(FFileHandle,Ps,0);
    FileRead(FFileHandle,Dh,sizeof(TDataHead));
    Decypher(Key,Password,3);
  end;
  result:=string(Dh.Password);
end;

procedure TSrmObject.SetDbChanged(Value:boolean);
begin
  FDbChanged:=Value;
end;

procedure TSrmObject.SetIndexChanged(Value:boolean);
begin
  FIndexChanged:=Value;
  if Value then FDbChanged:=Value;
end;

procedure TSrmObject.SetItemHeadChanged(Value:boolean);
begin
  FItemHeadChanged:=Value;
  if Value then
  begin
    FIndexChanged:=Value;
    FDbChanged:=Value;
  end;
end;

procedure TSrmObject.SetItemDataChanged(Value:boolean);
begin
  FItemDataChanged:=Value;
  if Value then
  begin
    FIndexChanged:=Value;
    FDbChanged:=Value;
  end;
end;



end.
